#
# OBJET  : Analyse du fichier d'activite IG Maktets (format texte seul)
# AUTEUR : Alain LL
# Version 3 : 	21/03/2012	Stat sur les trades : positifs, ngatifs et efficacit
# Version 4 : 	21/04/2012	Duree d'exposition au march
# Version 5 : 	25/04/2012	Mise de cot des positions over night (OVN)
# Version 6 :	26/04/2012	Support du format de UTF16, et parametrage des valeurs de contrat dans contrat.txt
# Version 7 :	16/05/2012	Ajout d'une zone [      ] pour annoter la perte max lors des review de trade
#                               Calcul du profit factor
# version 8.0 : 23/05/2012	Correction d'un bug de parsing de rfrence pour un ordre stop + limite
# version 8.1 : 08/06/2012	Traitememt du cas des positions agreges, un ordre peut fermer plusieurs positions
# version 8.2 : 28/06/2012	Fichier Synthse
# version 8.3 : 31/07/2012	Sous/total dans le fichier synthse

#--- Parametres
$FIC="order.csv";
$DATA="contrats.txt";
$SEUIL = 2;

open(IN, "<:encoding(UTF-16)", $FIC) || die("PB ouverture $FIC");
open(OUT, ">" , "res.txt");
open(SYN, ">" , "res_syn.txt");

$odate="-";
$pv_jour = 0; $positif = 0; $negatif = 0; $flat = 0;	
$tpos = 0; $tneg = 0;
$duree_tr = 0; $nb_tr = 0;


#--- chargement des prix des contrats depuis un fichier UTF-16 (format : valeur; nom_contrat;)
open(DT, "<:encoding(UTF-16)", $DATA) || die("PB ouverture $DATA");
while ( <DT> )
{
	($valeur, $contrat) = ( $_ =~/([^;]+)/g ) ;
	$prix { $contrat } = $valeur;
}
close DT;

#--- lecture du fichier des transactions IGM
while ( <IN> )
{
	($date, $time, $type, $contrat, $echance, $canal, $devise, $qte, $cours, 
		$stop, $type_stop, $limite, $res)  = ( $_ =~/([^\t]+)/g ) ;

# reference transaction
	if ($res =~ /[^:]+: (\w+)/) { $ref = $1; }

# DEBUG
#	printf OUT "== DATE $date / TIME $time / TYPE $type / CONTRAT $contrat / REF $ref / RES $res \n" ;

# changemement de jour
	if ($odate != $date) {
		if ($odate != "-") {	do_total();	}
		printf OUT "\n==================== $date ==================== \n";
		printf SYN "$date === ";
		$odate = $date;
	}


	if (/Position ouverte:/) {
		$cours_close = $my_cours {$ref};
		$time_close = $my_time {$ref};
		$date_close = $my_date {$ref};
		$libel = substr($contrat, 0, 12);
		if ($cours_close > 0)
		{
			$bilan = $qte * ($cours_close - $cours);
			$pv = $bilan * $prix {$contrat};
			if ($pv > 0)  { $positif += 1; $tpos += $pv}
			if ($pv < 0)  { $negatif += 1; $tneg += $pv}
			if ($pv == 0) { $flat += 1; }
			$pv_jour += $pv;

			#--- duree d'exposition au marche
			if ($date != $date_close)
			{
				$info = "++ OVN";
			}
			else {
				$hhmn_close = substr($time_close, 0, 2)*60 + substr($time_close, 3, 2);
				$hhmn_open  = substr($time, 0, 2)*60 + substr($time, 3, 2);
				$duree = $hhmn_close - $hhmn_open;
				$duree_tr += $duree;
				$nb_tr += 1;

				if ($duree > $SEUIL)	{	$info = sprintf "%smn", $duree;	} 
				else 			{	$info = "-";			}
			}

			printf OUT "%s  %s   %+.2f  [      ] %7s  %s / %s %7s = %+6.2f /  %+7.2f  %s\n", 
				$ref, $libel, $qte, $cours, $time,
				$time_close, $cours_close, $bilan, $pv, $info ;
		}
		else {
			printf OUT "%s  %s   %+.2f   %7s   OPEN   %s / \n", 
				$ref, $libel, $qte, $cours, $time;


		}
	}

	if (/ferme\(s\)/) {
#		printf OUT "CLOSE %s %.35s %+.2f %6s %s\n", $time, $contrat, $qte, $cours, $ref;
		$my_cours {$ref} = $cours;
		$my_time {$ref} = $time;
		$my_date {$ref} = $date;

		# cas de 2 positions agrges (TODO : traiter les cas > 2 )
		if ($res =~ m/\|/) {
			if ($res =~ /.* \| (\w+)/) { $ref2 = $1; }
#			printf OUT ">>>position groupe : res=<%s> ref=<%s> ref2=<%s>\n", $res, $ref, $ref2 ;
			$my_cours {$ref2} = $cours;
			$my_time {$ref2} = $time;
			$my_date {$ref2} = $date;
		}


	}

	$n += 1;


}
do_total();
do_final();


#-------------------
sub do_total() 
{

	if ($positif+$negatif > 0 && $nb_tr > 0) {

		if ($tpos == 0)		{ $PF = "---";}
		if ($tneg == 0)		{ $PF = "+++";}
		else 			{ $PF = sprintf "%.1f", -$tpos/$tneg; } 
	
		printf OUT "\nResultat = %+8.2f  (+)%2d (-)%2d (=)%2d efficacite %d%% P-Factor %s  exposition %dmn soit %.1fmn/TR\n", 
			$pv_jour, $positif, $negatif, $flat, $positif*100/($positif+$negatif), 
			$PF,
			$duree_tr, $duree_tr/$nb_tr;

		printf SYN " %+8.2f  (+)%2d (-)%2d (=)%2d eff. %3d%% P-Factor %s  exposition %dmn soit %.1fmn/TR\n", 
			$pv_jour, $positif, $negatif, $flat, $positif*100/($positif+$negatif), 
			$PF,
			$duree_tr, $duree_tr/$nb_tr;
	} else {
		printf OUT "\nResultat = %+.2f  (+)%2d (-)%2d \n", 
			$pv_jour, $positif, $negatif;

		printf SYN " %+8.2f  (+)%2d (-)%2d \n", 
			$pv_jour, $positif, $negatif;

	}

# --- gestion des cumuls
	$cumul_pv += $pv_jour;
	$cumul_positif += $positif;
	$cumul_negatif += $negatif;
	$cumul_flat += $flat;
	$cumul_tpos += $tpos;
	$cumul_tneg += $tneg;
	$cumul_duree_tr += $duree_tr;
	$cumul_nb_tr += $nb_tr;

# --- RAZ des stat jours
	$pv_jour = 0; 
	$positif = 0; 
	$negatif = 0;
	$flat = 0;
	$tpos = 0;
	$tneg = 0;
	$duree_tr = 0;
	$nb_tr = 0;
}

#-------------------
sub do_final() 
{
	if ($cumul_tpos == 0)		{ $PF = "---"; $POS = 0.0; $NEG = $cumul_tneg/$cumul_negatif; }
	if ($cumul_tneg == 0)		{ $PF = "+++"; $NEG = 0.0; $POS = $cumul_tpos/$cumul_positif; }
	else 				{ 
					  $PF = sprintf "%.1f", -$cumul_tpos/$cumul_tneg; 
					  $POS = $cumul_tpos/$cumul_positif;
					  $NEG = $cumul_tneg/$cumul_negatif; 
					} 

	if ($cumul_positif+$cumul_negatif > 0 && $cumul_nb_tr > 0) {

		printf SYN "S/TOTAL  ***  %+8.2f  (+)%2d (-)%2d (=)%2d eff. %3d%% P-Factor %s  /TR:   %.1fmn  %+8.2f  %+8.2f\n", 
			$cumul_pv, $cumul_positif, $cumul_negatif, $cumul_flat, $cumul_positif*100/($cumul_positif+$cumul_negatif), 
			$PF,
			$cumul_duree_tr/$cumul_nb_tr,
			$POS, $NEG;
	}
	else {
		printf SYN "Pas de cumul\n";

	}
}
